std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType > Class Template Reference
Random Number Generators

## Public Types

typedef _UIntType | result_type

## Public Member Functions

| independent_bits_engine ()
| independent_bits_engine (const _RandomNumberEngine &__rng)
| independent_bits_engine (_RandomNumberEngine &&__rng)
| independent_bits_engine (result_type __s)
template<typename _Sseq , typename = typename std::enable_if<!std::is_same<_Sseq, independent_bits_engine>::value && !std::is_same<_Sseq, _RandomNumberEngine>::value> ::type>
| independent_bits_engine (_Sseq &__q)
const _RandomNumberEngine & | base () const noexcept
void | discard (unsigned long long __z)
result_type | operator() ()
void | seed ()
void | seed (result_type __s)
template<typename _Sseq >
void | seed (_Sseq &__q)

## Static Public Member Functions

static constexpr result_type | max ()
static constexpr result_type | min ()

## Friends

bool | operator== (const independent_bits_engine &__lhs, const independent_bits_engine &__rhs)
template<typename _CharT , typename _Traits >
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType > &__x)

## Detailed Description

### template<typename _RandomNumberEngine, size_t __w, typename _UIntType>
class std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >

Produces random numbers by combining random numbers from some base engine to produce random numbers with a specifies number of bits `__w`.

Definition at line 1074 of file random.h.

## Member Typedef Documentation

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

typedef _UIntType std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::result_type

The type of the generated random value.

Definition at line 1077 of file random.h.

## Constructor & Destructor Documentation

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::independent_bits_engine | ( |  | ) |

inline

Constructs a default independent_bits_engine engine.

The underlying engine is default constructed as well.

Definition at line 1090 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::independent_bits_engine | ( | const _RandomNumberEngine & | __rng | ) |

inlineexplicit

Copy constructs a independent_bits_engine engine.

Copies an existing base class random number generator.

Parameters

  __rng | An existing (base class) engine object.

Definition at line 1100 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::independent_bits_engine | ( | _RandomNumberEngine && | __rng | ) |

inlineexplicit

Move constructs a independent_bits_engine engine.

Copies an existing base class random number generator.

Parameters

  __rng | An existing (base class) engine object.

Definition at line 1110 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::independent_bits_engine | ( | result_type | __s | ) |

inlineexplicit

Seed constructs a independent_bits_engine engine.

Constructs the underlying generator engine seeded with `__s`.

Parameters

  __s | A seed value for the base class engine.

Definition at line 1120 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>
template<typename _Sseq , typename = typename std::enable_if<!std::is_same<_Sseq, independent_bits_engine>::value && !std::is_same<_Sseq, _RandomNumberEngine>::value> ::type>

std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::independent_bits_engine | ( | _Sseq & | __q | ) |

inlineexplicit

Generator construct a independent_bits_engine engine.

Parameters

  __q | A seed sequence.

Definition at line 1133 of file random.h.

## Member Function Documentation

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

const _RandomNumberEngine& std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::base | ( |  | ) | const

inlinenoexcept

Gets a const reference to the underlying generator engine object.

Definition at line 1168 of file random.h.

Referenced by std::operator<<().

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

void std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::discard | ( | unsigned long long | __z | ) |

inline

Discard a sequence of random numbers.

Definition at line 1189 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

static constexpr result_type std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::max | ( |  | ) |

inlinestatic

Gets the maximum value in the generated random number range.

Definition at line 1182 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

static constexpr result_type std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::min | ( |  | ) |

inlinestatic

Gets the minimum value in the generated random number range.

Definition at line 1175 of file random.h.

template<typename _RandomNumberEngine , size_t __w, typename _UIntType >

independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::result_type std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::operator() | ( |  | ) |

Gets the next value in the generated random number sequence.

Definition at line 745 of file bits/random.tcc.

References std::__lg(), std::numeric_limits< _Tp >::max(), and std::numeric_limits< _Tp >::min().

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

void std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::seed | ( |  | ) |

inline

Reseeds the independent_bits_engine object with the default seed for the underlying base class generator engine.

Definition at line 1142 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

void std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::seed | ( | result_type | __s | ) |

inline

Reseeds the independent_bits_engine object with the default seed for the underlying base class generator engine.

Definition at line 1150 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>
template<typename _Sseq >

void std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType >::seed | ( | _Sseq & | __q | ) |

inline

Reseeds the independent_bits_engine object with the given seed sequence.

Parameters

  __q | A seed generator function.

Definition at line 1160 of file random.h.

## Friends And Related Function Documentation

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>

bool operator== | ( | const independent_bits_engine< _RandomNumberEngine, __w, _UIntType > & | __lhs,
|  | const independent_bits_engine< _RandomNumberEngine, __w, _UIntType > & | __rhs
| ) |  |

friend

Compares two independent_bits_engine random number generator objects of the same type for equality.

Parameters

  __lhs | A independent_bits_engine random number generator object.
  __rhs | Another independent_bits_engine random number generator object.

Returns
  true if the infinite sequences of generated values would be equal, false otherwise.

Definition at line 1214 of file random.h.

template<typename _RandomNumberEngine, size_t __w, typename _UIntType>
template<typename _CharT , typename _Traits >

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | std::independent_bits_engine< _RandomNumberEngine, __w, _UIntType > & | __x
| ) |  |

friend

Extracts the current state of a % subtract_with_carry_engine random number generator engine `__x` from the input stream `__is`.

Parameters

  __is | An input stream.
  __x | A independent_bits_engine random number generator engine.

Returns
  The input stream with the state of `__x` extracted or in an error state.

Definition at line 1232 of file random.h.

The documentation for this class was generated from the following files:

- random.h
- bits/random.tcc